	.8086		;COM MODEL
;
;HEX2COM   version 0.00
;(C)1995,2013 wnc develop
;1995.12.31(SUN)
;2013.10.29(TUE)
;
;CZX(QBSDX^CCZXj
;2013N10 wnc develop
;---------------------------------------------------------
;Copyright (c) 1995,2013 wnc / t.w.
;All rights reserved.
;
;Redistribution and use in source and binary forms,
; with or without modification, are permitted provided that 
;the following conditions are met:
;
;1. Redistributions of source code must retain the above copyright notice,
;   this list of conditions and the following disclaimer.
;2. Redistributions in binary form must reproduce the above copyright notice,
;   this list of conditions and the following disclaimer in
;   the documentation and/or other materials provided with the distribution.
;
;THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
; "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
; BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
; AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
; IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
; ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
; DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
; GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
; INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
; (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
; USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;---------------------------------------------------------
;
	INCLUDE	HEX2COM.H
;
PUTC	MACRO	CHR
	PUSH	AX
	MOV	AL,CHR
	INT	29H
	POP	AX
	ENDM
;
DMA	EQU	0080H
;
CODE	SEGMENT	WORD PUBLIC
	ASSUME	CS:CODE,DS:CODE,ES:CODE
;
	ORG	0100H		;X^[gAhX
;
START:	JMP	short MAIN	;vOJnAhX
;
VER	DB	"  HEX2COM  v0.00   "	;PROGRAM NAME AND VER.
	DB	'(C)1995,2013 wnc develop'
	DB	0,CR,LF
;
;
MAIN:	MOV	B_MAX,worp 0	;MEMORY CLEAR.
	MOV	FNF,bytp 0	;MEMORY CLEAR.
;
	PRINT	M_COPY		;OUTPUT IS COPYRIGHT.
;
	CALL	CHKDMA	;͂Ă邩mF(RET Cy=1:ERROR)
	LJC	ERR1
	CALL	MOVFIL	;t@C[NGAɃRs[
	CALL	OPENF1	;]t@CI[v(RET Cy=1:ERROR)
	LJC	ERR2
	CALL	OPENF2	;]t@CVKɃI[v(RET Cy=1:ERROR)
	LJC	ERR3
;
	CALL	GETMEM	;64KBm(RET AX=SEGADDR,Cy=1:ERR)
	LJC	MEMERR
	MOV	B_MEM,AX
;
	CALL	MEMCLR	;MEMORY CLEAR 64KB(SET B_MEM:CLEAR ADDR)
;
	PRINT	M_WORK
;
;Ro[^{
LPMAIN:	CALL	RDLNF1	;READ 1 LINE.(Cy=1:END OF FILE)
	LJC	ERR4
	CALL	CNVA2B	;ASC TO BIN(Cy=1 and AX=1:ERROR,Cy=1 and AX=0:END)
;
	PUSHF
	PUTC	'.'
	POPF
;
	JNC	LPMAIN
	TEST	AX,AX
	LJNZ	ERR4
;
	JMP	short CLOSF2
;
PAUSE:	PUSHF
	PUSH	AX
	PRINT	SYSOK
	MOV	AH,08H
	INT	21H
	POP	AX
	POPF
	RET
;
SYSOK	DB	'O.K.',CR,LF,'$'
;
D_PERR	DB	'SYSTEM ERROR',CR,LF,'$'
PRGERR:	PRINT	D_PERR
	ERREND
;-----------------------------------
;]t@CN[YivZsj
CLOSF2:
	PUSH	AX
	MOV	AL,':'
	INT	29H
	POP	AX
;
	MOV	AX,CS
	MOV	ES,AX
	MOV	AX,B_MEM
	MOV	DS,AX
;
	MOV	AX,ES:B_MAX
	CMP	AX,32768
	JNC	MOVE_2
	JMP	short MOVE_1
;
MOVE_2:	MOV	CX,32768
;
	MOV	SI,0
	MOV	DI,ofs WRBUF
	CLD
	REPNZ	MOVSB
;
	MOV	AX,CS
	MOV	DS,AX
	MOV	CX,32768
;
	MOV	DX,ofs WRBUF
;
	CMP	FNF,0
	JNZ	NOMAL2
;
	ADD	DX,0100H	;256BYTE SKIP
	SUB	CX,0100H	;256BYTE DELETE
;
NOMAL2:	MOV	AH,40H
	MOV	BX,FH2
	INT	21H
;
	LJC	C_ERR
	CMP	AX,CX
	LJNZ	C_ERR3
;
	MOV	AX,B_MAX
	SUB	AX,32768
;
	MOV	CX,AX
;	INC	CX
;
	PUSH	CX
	PUSH	DS
	MOV	AX,B_MEM
	MOV	DS,AX
	MOV	SI,32768
	MOV	DI,ofs WRBUF
	REPNZ	MOVSB
	POP	DS
	POP	CX
;
	MOV	AH,40H
	MOV	DX,ofs WRBUF
	MOV	BX,FH2
	INT	21H
;
	LJC	C_ERR
	CMP	AX,CX
	LJNZ	C_ERR3
;
	JMP	short C_HAND
;
MOVE_1:	MOV	CX,AX
;;;	INC	CX	;ADDR+1
;
	PUSH	CX
	MOV	SI,0
	MOV	DI,ofs WRBUF
	CLD
	REPNZ	MOVSB
	POP	CX
;
	MOV	AX,CS
	MOV	DS,AX
;
;
	MOV	DX,ofs WRBUF
;
	CMP	FNF,0
	JNZ	NOMAL
;
	ADD	DX,0100H	;256BYTE SKIP
	SUB	CX,0100H	;256BYTE DELETE
;
NOMAL:	MOV	AH,40H
	MOV	BX,FH2
	INT	21H
;
	JC	C_ERR
	CMP	AX,CX
	JNZ	C_ERR3
	JMP	short C_HAND
;
;WORK CLOSE HANDLE.
C_HAND:
	PUTC	';'
;
	MOV	AH,3EH
	MOV	BX,FH2
	INT	21H
	LJC	DSKERR
;
	PRINT	M_COMP
;
	ERREND
;
CD_ERR1	DB	'ACCESS ERR',CR,LF,'$'
CD_ERR2	DB	'HANDLE ERR',CR,LF,'$'
CD_ERR3	DB	'DISK NOT FREE SPACE',CR,LF,'$'
C_ERR:	CMP	AX,05H
	JZ	C_ERR1
	JMP	short C_ERR2
;
C_ERR1:	PRINT	CD_ERR1
	ERREND
C_ERR2:	PRINT	CD_ERR2
	ERREND
C_ERR3:	PRINT	CD_ERR3
	ERREND
;
;-----------------------------------
;AXL[R[ĥPUiɖ߂֐
CNVA2B:	PUSH	BX
	PUSH	CX
	PUSH	DX
	PUSH	ES
	CLD
	MOV	AX,B_MEM
	MOV	ES,AX
;
	MOV	DL,0		;CRC COUNTER.
;
	MOV	SI,ofs FBUF
L1A2B:	LODSB
	CMP	AL,':'
	JNZ	L1A2B
;
	LODSW			;COUNT VAL.
	XCHG	AH,AL
	CALL	ASC2HEX16	;RET AH=0,AL=HEX
	MOV	CX,AX		;SET COUNTER
	ADD	DL,AL		;ADD CRC
	LODSW
	XCHG	AH,AL
	CALL	ASC2HEX16
	MOV	BH,AL		;SET ADDR HIGH.
	ADD	DL,AL		;ADD CRC
	LODSW
	XCHG	AH,AL
	CALL	ASC2HEX16
	MOV	BL,AL		;SET ADDR LOW.
	ADD	DL,AL		;ADD CRC.
	MOV	DI,BX		;SET ADDR.
;
	LODSW
	XCHG	AH,AL
	CALL	ASC2HEX16
	ADD	DL,AL		;ADD CRC.
	CMP	AL,01H		;END CODE.
	JZ	J1A2B
	TEST	AL,AL
	JNZ	J2A2B
;
L2A2B:	LODSW
	XCHG	AH,AL
	CALL	ASC2HEX16
	ADD	DL,AL		;ADD CRC.
	STOSB
;
	CMP	DI,B_MAX
	JC	@F
	MOV	B_MAX,DI
@@:
	LOOP	L2A2B
;
	CLC
;
;CRC CHK
CVA2BE:	LODSW
	XCHG	AH,AL
	CALL	ASC2HEX16
	ADD	DL,AL
	TEST	DL,DL
	JNZ	J2A2B		;NO HEXFILE.
;
	CLC
;
CVA2BX:	POP	ES
	POP	DX
	POP	CX
	POP	BX
	RET
;
;CRC CHK.
J1A2B:	LODSW
	XCHG	AH,AL
	CALL	ASC2HEX16
	ADD	DL,AL
	TEST	DL,DL
	JNZ	J2A2B
;
	MOV	AX,0	;HEX FILE END.
	STC
	JMP	short CVA2BX
;
J2A2B:	MOV	AX,1	;ERROR(HEX FILE ERROR)
	STC
	JMP	short CVA2BX
;
;Ɗ֐
;IN AL=ASCII CODE,OUT AL=HEX
ASC2HEX:
	PUSHF
	SUB	AL,30H
	CMP	AL,10H
	JC	A2H_E
	SUB	AL,7
A2H_E:
;	AND	AL,0FH
	POPF
	RET
;
;Ɗ֐
;IN AX=ASCII CODE(2BYTE),OUT [AH=0,AL=HEX]
ASC2HEX16:
	PUSHF
	PUSH	BX
	MOV	BX,AX
	CALL	ASC2HEX
	MOV	BL,AL
	MOV	AL,BH
	CALL	ASC2HEX
	SHL	AL,1
	SHL	AL,1
	SHL	AL,1
	SHL	AL,1
	OR	AL,BL
	MOV	AH,0
	POP	BX
	POPF
	RET
;
;-----------------------------------
;Psǂݏoi]j
RDLNF1:	PUSHX
	PUSHI
	MOV	SI,ofs FBUF
	MOV	DI,0	;COUNTER
;
L1RLF1:	MOV	AH,3FH		;RD HANDLE
	MOV	DX,SI		;BUF ADDR.
	MOV	CX,1		;RD BYTE.
	MOV	BX,FH1		;FILE HANDLE 1
	INT	21H
	LJC	PRGERR
;
	TEST	AX,AX
	JNZ	@F
	STC
	JMP	short RLNF1E
;
@@:	CMP	[SI],BYTP CR
	JZ	RLNF1E
;
	INC	SI
	INC	DI
	CMP	DI,1024		;MAX BUFFER
	LJNC	ERR4
	JMP	short L1RLF1
;
RLNF1E:	POPI
	POPX
	RET
;-----------------------------------
;USm
GETMEM:	PUSH	BX
	PUSH	ES
	MOV	AX,CS
	MOV	ES,AX
	MOV	BX,1000H	;64K(PARA)
	MOV	AH,4AH		;SET BLOCK
	INT	21H
;
	LJC	PRGERR		;SYSTEM ERROR(HEX2COM)
;
	MOV	AH,48H
	MOV	BX,1000H	;64K(PARA)
	INT	21H
;
	POP	ES
	POP	BX
	RET
;;-------------------------
;	MOV	AX,CS
;	ADD	AX,1000H
;
;-----------------------------------
;MEMORY CLEAR(64KB)
MEMCLR:	PUSHF
	PUSH	AX
	PUSH	CX
	PUSH	DI
	PUSH	ES
	CLD
	MOV	AX,B_MEM
	MOV	ES,AX
;
	MOV	AL,0
	MOV	DI,0
	MOV	CX,0FFFFH
	REPNZ	STOSB
;
	POP	ES
	POP	DI
	POP	CX
	POP	AX
	POPF
	RET
;-----------------------------------
;]t@CI[v
;RET Cy(1=can't open,0=no error)
OPENF1:	PUSH	AX
	PUSH	DX
	MOV	AH,3DH
	MOV	AL,0
	MOV	DX,ofs FN1
	INT	21H
	JC	OPF1E
	MOV	FH1,AX
OPF1E:	POP	DX
	POP	AX
	RET
;-----------------------------------
;]t@CVKI[v
;RET Cy(1=can't open,0=no error)
OPENF2:	PUSH	AX
	PUSH	CX
	PUSH	DX
	MOV	AH,3CH
	MOV	CX,0		;ʏt@C
	MOV	DX,ofs FN2
	INT	21H
	JC	OPF2E
	MOV	FH2,AX
OPF2E:	POP	DX
	POP	CX
	POP	AX
	RET
;-----------------------------------
;t@C[NɃRs[
;RET no
MOVFIL:	PUSHF
	PUSHX
	PUSHI
;
	CLD
;
	MOV	SI,ofs DMA+1
	MOV	DI,ofs FN1
;
L1MF1:	LODSB
	CMP	AL,' '
	JZ	L1MF1
	CMP	AL,09H
	JZ	L1MF1
;
L2MF1:	TEST	AL,AL
	JZ	MOVF1E
	CMP	AL,09H
	JZ	MOVF1E
	CMP	AL,' '
	JZ	MOVF1E
	CMP	AL,','
	JZ	MOVF1E
	STOSB
	LODSB
	JMP	short L2MF1
;
MOVF1E:	MOV	AL,0	;FILE END MARK.
	STOSB
;
;FILE2
	MOV	DI,ofs FN2
;
L1MF2:	LODSB
	CMP	AL,' '
	JZ	L1MF2
	CMP	AL,09H
	JZ	L1MF2
;
L2MF2:	TEST	AL,AL
	JZ	MOVF2E
	CMP	AL,CR
	JZ	MOVF2E
	CMP	AL,09H
	JZ	MOVF2E
	CMP	AL,' '
	JZ	MOVF2E
	CMP	AL,';'
	JZ	MOVF2E
	CMP	AL,'/'
	JZ	MOVF2E
	STOSB
	LODSB
	JMP	short L2MF2
;
MOVF2E:	PUSH	AX
	MOV	AL,0	;FILE END MARK.
	STOSB
	POP	AX
	TEST	AL,AL
	JZ	MOVFXE
	CMP	AL,CR
	JZ	MOVFXE
	JMP	short L2MFX
;
L1MFX:	LODSB
L2MFX:	CMP	AL,' '
	JZ	L1MFX
;
	CMP	AL,'/'
	JZ	J2MFX
	CMP	AL,'-'
	JZ	J2MFX
	JMP	short MOVFXE
;
J2MFX:	LODSB
	CMP	AL,'N'
	JZ	J1MFX
	CMP	AL,'n'
	JZ	J1MFX
	JMP	short MOVFXE
;
J1MFX:	MOV	FNF,bytp 0FFH	;0=MSXCOM,0<>BIN
;
MOVFXE:	POPI
	POPX
	POPF
	RET
;-----------------------------------
;𔻒f邽߂̊֐
;RET Cy(1=,0=)
CHKDMA:	PUSHF
	PUSH	AX
	PUSH	BX
	MOV	BX,DMA
	MOV	AL,[BX]	;DMA
	TEST	AL,AL
	JNZ	CDMA_E
;
	POP	BX
	POP	AX
	POPF
	STC		;NO CHR(CY=1)
	RET
;
CDMA_E:	POP	BX
	POP	AX
	POPF
	CLC		;0<CHR(Cy=0)
	RET
;-----------------------------------
;G[
ERR1:	PRINT	M_NOCHR
	ERREND
;
ERR2:	PRINT	M_NOFL1
	JMP	short ERR1
;
ERR3:	PRINT	M_NOFL2
	JMP	short ERR1
;
ERR4:	PRINT	M_ASCER
	ERREND
;
MEMERR:	PRINT	M_MERR
	ERREND
;
DSKERR:	PRINT	M_DERR
	ERREND
;-----------------------------------
;
M_MERR	DB	'OUT OF MEMORY',CR,LF,'$'
M_NOFL1	DB	'HEX file ERROR',CR,LF,'$'
M_NOFL2	DB	'OUTPUT file ERROR',CR,LF,'$'
M_ASCER	DB	CR,LF,'HEX import error , convert stopped',CR,LF,'$'
M_DERR	DB	CR,LF,'Disk error.',CR,LF,'$'
;
M_COPY	DB	'  HEX >> COM  file CONVERTER '
	DB	'(C)1995,2013 wnc develop ',CR,LF,LF,'$'
M_NOCHR	DB	' HEX2COM <HEXfile> <OUTPUTfile> [/N]',CR,LF
	DB	'     /N   :NORMAL FILE (NOT MSXDOS FILE)',CR,LF,LF
	DB	'intel HEX to BIN(COM) FILE convert',CR,LF,'$'
;
M_WORK	DB	'CPU is at work now.',CR,LF,'$'
M_COMP	DB	CR,LF,'completed.',CR,LF,'$'
;
	DB	'_HEX2COM_'
;
FN1	DB	128 DUP(?)	;]t@C
FH1	DW	1 DUP(?)	;]t@Cnh
FN2	DB	128 DUP(?)	;]t@C
FH2	DW	1 DUP(?)	;]t@Cnh
;
FNF	DB	1 DUP(?)	;FRAG(0=MSXCOM,0<>BIN)
;
B_MEM	DW	1 DUP(?)	;蓖Ăꂽ̐擪pOt
B_MAX	DW	1 DUP(?)	;USED MEM MAX ADDR.
;
FBUF	DB	1024 DUP(?)	;DISK BUFFER
;
WRBUF	DB	32768 DUP(?)	;DISK WRITE BUFFER
;
CODE	ENDS
	END	START
