	.8086
;
;chkcpu v0.03(kmswx v2.00_08)
;(C)1997,2013 wnc develop
;
;CZX(QBSDX^CCZXj
;2013N10 wnc develop
;---------------------------------------------------------
;Copyright (c) 1997,2013 wnc / t.w.
;All rights reserved.
;
;Redistribution and use in source and binary forms,
; with or without modification, are permitted provided that 
;the following conditions are met:
;
;1. Redistributions of source code must retain the above copyright notice,
;   this list of conditions and the following disclaimer.
;2. Redistributions in binary form must reproduce the above copyright notice,
;   this list of conditions and the following disclaimer in
;   the documentation and/or other materials provided with the distribution.
;
;THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
; "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
; BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
; AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
; IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
; ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
; DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
; GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
; INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
; (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
; USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;---------------------------------------------------------
;
	INCLUDE	CHKCPU.H
;
;
;--------------------------------
;N@̓
;--------------------------------
;<970214>
;<970508>REV V0.02
;<970602>REV V0.03
;CPU`
;
V_CPU	EQU	8		;FłCPU̐
;
I8086	EQU	1
I186	EQU	2
I286	EQU	3
I386	EQU	4
I486	EQU	5
I586	EQU	6
I686	EQU	7
V30	EQU	0
;
CODE	SEGMENT	WORD PUBLIC
	ASSUME	CS:CODE,DS:CODE,ES:CODE
;
	ORG	0100H		;COMMODEL
;
START:	JMP	MAIN
;
M2CCPU	DB	'CCPU V0.03 CPU:','$'
;
C8086	DB	'i8086 $'
C80186	DB	'i80186 $'
C80286	DB	'i80286 $'
C80386	DB	'i80386 $'
C80486	DB	'i80486 $'
C80586	DB	'pentium $'
C80686	DB	'pentium PRO $'
CV30	DB	'uPD70116(V30) $'
CXXXX	DB	'XXXX$'
CPUODP	DB	'ODP $'
CPUV86	DB	'V86 mode ',CR,LF,'$'
CPUREAL	DB	' ',CR,LF,'$'
CPUMMX	DB	'MMX $'
;
;
T_CPU	DW	CV30,C8086,C80186,C80286,C80386,C80486	;0,1,2,3,4,5
	DW	C80586,C80686				;6,7,8,9,10
;
MAIN:	PRINT	M2CCPU		;'CCPU V0.03...'
	CALL	CCPU
	MOV	AX,4C00H	;MS-DOS֖߂
	INT	21H
;
;
;CPUAʂɏo
CCPU:
	PUSHF
	PUSHX
;
;
	SUB	AX,AX		;AX=0
	MOV	W_CPU,AX
	MOV	W_CPUUP,AL
	MOV	W_MMX,AL
	MOV	W_V86,AL
;
;CPUvO
	CALL	S_CCPU		;<970505>RET AX=CPUVAL
;
;CPUԍ̌
	CMP	AX,V_CPU
	JNC	E_CCPU		;<970508>KO̐l
;
;ްײ۾H
;ODP OUTPUT
	PUSH	AX
	CMP	W_CPUUP,bytp 10H	;ODP=10H
	JNZ	@F
	PRINT	CPUODP		;'ODP'
@@:
;
;MMX OUTPUT
	CMP	W_MMX,bytp 0	;0=,1=MMX
	JZ	@F
	PRINT	CPUMMX		;'MMX'
@@:
	POP	AX
;
;CPUNAME OUTPUT.
	SHL	AX,1		;<970505>AX*2
	ADD	AX,ofs T_CPU	;<970505>
	MOV	BX,AX
	MOV	DX,[BX]		;<970505>NAME擾
	MOV	AH,09H		;<970505>OUT SCREEN
	INT	21H		;MS-DOS CALL
;
;CPU MODE OUTPUT.
	MOV	DX,ofs CPUREAL	;'',CR,LF,'$'
	CMP	W_V86,bytp 0	;0=REAL,1=V86
	JZ	@F
	MOV	DX,ofs CPUV86	;'V86',CR,LF,'$'
@@:
	MOV	AH,09H
	INT	21H
;
;PROGRAM END.
E_CCPU:
	POPX
	POPF
	RET
;
;CPU۸-------------
;RET AX=CPUԍ(0=V30,1=8086,2=186...)
;<970508>
S_CCPU:
	CALL	S1CCPU		;<970505>Cy=0:8086+V30,Cy=1:80186...
	JC	J1CCPU
	CALL	S0CCPU		;<970505>Cy=0:8086,Cy=1:V30
	JC	J3CCPU
	MOV	AX,I8086	;1=8086
	RET
J1CCPU:
	CALL	S2CCPU		;<970505>Cy=0:80186,Cy=1:286...
	JC	J2CCPU		;186łȂ
	MOV	AX,I186		;2=80186
	RET
J2CCPU:
	CALL	S3CCPU		;<970505>AL=CPUVAL(80286,386,486..)
	RET
;
J3CCPU:
	MOV	AX,V30		;V30
	RET
;
;8086/V30̌
S0CCPU:
;	AAD	00		;INTEL̉BZ
	MOV	AX,0100H
	DB	0D5H,00H	;ϼ݌
	JZ	J1S0CCPU	;Z=1:8086,Z=0:V30
;
;V30ذނ
	STC
	RET
;
;8086ذނ
J1S0CCPU:
	CLC
	RET
;
;8086,V30..,80186/286...̌
S2CCPU:
	PUSHF
	POP	AX		;<970505>AH+AL
	AND	AH,0F0H		;<970505>b15,b14,b13,b12,MASK
	CMP	AH,0F0H		;<970505>
	JNZ	J1S2CCPU	;8086,186łȂ.
;
;8086,186
	CLC
	RET
;
;286ȍ~
J1S2CCPU:
	STC
	RET
;
S1CCPU:
	PUSH	CX
	MOV	AL,01H
	MOV	CL,20H
	SHR	AL,CL
	POP	CX
	OR	AL,AL
	JNZ	J1S1CCPU
;
;8086,V30,V33,V50ł
	CLC			;<970505>CLEAR Cy
	RET
;
;8086,V30,V33,V50łȂ
J1S1CCPU:
	STC
	RET
;
;80286,386,486...
S3CCPU:
	PUSHF			;S4:BACKUP
	PUSHF			;S1
	POP	AX		;R1<970505>AX<<FLAG
	OR	AX,4000H	;<970505>AXb141ɐݒ
	PUSH	AX		;S2
	POPF			;R2<970505>FLAG<<AX(SETUP)
	PUSHF			;S3
	POP	AX		;R3<970505>AX<<FLAG(RECOVER)
	POPF			;R4:RECOVER
;
	AND	AX,0C000H	;<970505>b15,b14 MASK.
	CMP	AX,4000H	;<970505>v80386,80486
	JZ	J1S3CCPU	;80386,80486̌
	MOV	AX,I286		;<970505>3=80286
	RET
;
;80386,80486̌
J1S3CCPU:
;V86 & REAL MODE CHK
	PUSH	BX
	PUSHF
	POP	AX
	PUSHF
	MOV	BX,AX
	XOR	AX,3000H
	PUSH	AX
	POPF
	PUSHF
	POP	AX
	POPF
	CMP	AX,BX
	POP	BX
	MOV	W_V86,bytp 0	;
	JNZ	@F	;REAL
	MOV	W_V86,bytp 1	;1=V86,0=REAL
@@:
;
	PUSH	BX
;
	.386
	MOV	BX,SP
	AND	SP,0FFFCH
	PUSHFD
	CLI
	PUSHFD
	POP	EAX
	OR	EAX,00040000H
	PUSH	EAX
	POPFD
	PUSHFD
	POP	EAX
	POPFD
	MOV	SP,BX
	TEST	EAX,00040000H
	.8086
	POP	BX
;
	JNZ	@F
	MOV	AX,I386		;386
	RET
@@:
;
;80486,80586̌
	.386
	PUSHFD
	PUSHFD
	POP	EAX
	OR	EAX,00200000H
	PUSH	EAX
	POPFD
	PUSHFD
	POP	EAX
	POPFD
	TEST	EAX,00200000H
	.8086
	JNZ	@F
;
	MOV	AX,I486		;486
	RET
@@:
;
;80586
;
;MMX
	.586
	PUSH	EDX
	MOV	EAX,1
	CPUID
	TEST	EDX,00800000H
	POP	EDX
	.8086
	JZ	@F
	MOV	W_MMX,bytp 1	;0=,1=MMX
@@:
;
	.586
	PUSH	EBX
	PUSH	ECX
	PUSH	EDX
	MOV	EAX,00000001H
	CPUID
	POP	EDX
	POP	ECX
	POP	EBX
	.8086
;
;ODP
	PUSH	AX
	AND	AH,0F0H		;ʃ}XN
	MOV	W_CPUUP,AH	;ODP
	POP	AX
;
	AND	AH,0FH
	CMP	AH,05H
	JNC	@F
	MOV	AX,I486		;80586(486)
	RET
@@:
	CMP	AH,05H
	JZ	@F
	MOV	AX,I686		;80686?
	RET
;
@@:	MOV	AX,I586		;80586
	RET
;------------------------------------------
W_CPU	DW	?
W_CPUUP	DB	?
W_MMX	DB	?
W_V86	DB	?
;
;
CODE	ENDS
	END	START
