;>>>>>>>>>>>>>>>>>>>>>>>>
;     WNCFIND.H v0.01
;(C)1997,2013 wnc develop
;<<<<<<<<<<<<<<<<<<<<<<<<
;
;CZX(QBSDX^CCZXj
;2013N10 wnc develop
;---------------------------------------------------------
;Copyright (c) 1997,2013 wnc / t.w.
;All rights reserved.
;
;Redistribution and use in source and binary forms,
; with or without modification, are permitted provided that 
;the following conditions are met:
;
;1. Redistributions of source code must retain the above copyright notice,
;   this list of conditions and the following disclaimer.
;2. Redistributions in binary form must reproduce the above copyright notice,
;   this list of conditions and the following disclaimer in
;   the documentation and/or other materials provided with the distribution.
;
;THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
; "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
; BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
; AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
; IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
; ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
; DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
; GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
; INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
; (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
; USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;---------------------------------------------------------
;    1995. 8.14(MON)
;rev 1996.12.07(SAT)
;rev 1997.12.27(SAT) PRINTA(PRINT ASCIZ)
;-----------------
;equ
STOP	EQU	03H
LF	EQU	0AH
CR	EQU	0DH
ESC_	EQU	1BH
;
OFS	EQU	OFFSET
BYTP	EQU	BYTE PTR
WORP	EQU	WORD PTR
;
;-----------------
;MACRO
;-----------------
;-----------
;PAUSE
PAUSE	MACRO
	LOCAL	J1,J2,J3
	PUSHF
	PUSH	AX
	PUSH	DX
J1:
	MOV	AH,06H
	MOV	DL,0FFH
	INT	21H
	JZ	J1
	CMP	AL,1BH
	JNZ	J2
	MOV	AX,4C00H
	INT	21H
J2:
	CMP	AL,03H
	JNZ	J3
	MOV	AX,4C00H
	INT	21H
J3:
	POP	DX
	POP	AX
	POPF
	ENDM
;----------
;
;DOBLE INC
WINC	MACRO	REG
	INC	REG
	INC	REG
	ENDM
;---------
;DOBLE DEC
WDEC	MACRO	REG
	DEC	REG
	DEC	REG
	ENDM
;---------
;PUSH ALL X
PUSHX	MACRO
	PUSH	AX
	PUSH	BX
	PUSH	CX
	PUSH	DX
	ENDM
;---------
;POP ALL X
POPX	MACRO
	POP	DX
	POP	CX
	POP	BX
	POP	AX
	ENDM
;---------
;PUSH SI DI
PUSHI	MACRO
	PUSH	SI
	PUSH	DI
	ENDM
;---------
;POP DI SI
POPI	MACRO
	POP	DI
	POP	SI
	ENDM
;---------
;PROGRAM END
ERREND	MACRO
	MOV	AL,00H
	MOV	AH,4CH
	INT	21H
	ENDM
;
;---------
;LONG JUMP NO ZERO
LJNZ	MACRO	ADDR
	LOCAL	LJNZE
	JZ	LJNZE
	JMP	ADDR
LJNZE:
	ENDM
;---------
;LONG JUMP ZERO
LJZ	MACRO	ADDR
	LOCAL	LJZE
	JNZ	LJZE
	JMP	ADDR
LJZE:
	ENDM
;---------
;LONG JUMP NO CARRY
LJNC	MACRO	ADDR
	LOCAL	LJNCE
	JC	LJNCE
	JMP	ADDR
LJNCE:
	ENDM
;---------
;LONG JUMP CARRY
LJC	MACRO	ADDR
	LOCAL	LJCE
	JNC	LJCE
	JMP	ADDR
LJCE:
	ENDM
;---------
;LONG JUMP NO PARI
LJNP	MACRO	ADDR
	LOCAL	LJNPE
	JP	LJNPE
	JMP	ADDR
LJNPE:
	ENDM
;---------
;LONG JUMP PARI
LJP	MACRO	ADDR
	LOCAL	LJPE
	JNP	LJPE
	JMP	ADDR
LJPE:
	ENDM
;----------------
;LONG JUMP NO SIGN
LJNS	MACRO	ADDR
	LOCAL	LJNSE
	JP	LJNSE
	JMP	ADDR
LJNSE:
	ENDM
;---------
;LONG JUMP SIGN
LJS	MACRO	ADDR
	LOCAL	LJSE
	JNS	LJSE
	JMP	ADDR
LJSE:
	ENDM
;---------
;EXT CALL (Z frag)
;951220
CALLZ	MACRO	ADDR
	LOCAL	CZE
	JNZ	CZE
	CALL	ADDR
CZE:
	ENDM
;//////
;951220
CALLNZ	MACRO	ADDR
	LOCAL	CNZE
	JZ	CNZE
	CALL	ADDR
CNZE:
	ENDM
;---------
;EXT CALL (C frag)
;951220
CALLC	MACRO	ADDR
	LOCAL	CCE
	JNC	CCE
	CALL	ADDR
CCE:
	ENDM
;//////
;951220
CALLNC	MACRO	ADDR
	LOCAL	CNCE
	JC	CNCE
	CALL	ADDR
CNCE:
	ENDM
;
;--------------------
;MACRO2
;--------------------
;
;KILL KEY BUFFER
KILKBUF	MACRO
	LOCAL	KILJ1
	PUSHF
	PUSH	AX
	PUSH	DX
	MOV	DH,32
KILJ1:	MOV	AH,06H
	MOV	DL,0FFH
	INT	21H
	DEC	DH
	JNZ	KILJ1
	POP	DX
	POP	AX
	POPF
	ENDM
;
BEEP	MACRO
	PUSH	AX
	MOV	AL,07H
	INT	29H
	POP	AX
	ENDM
;
;PRINT ASCIZ DIRECT
;971228p
;INT 21_02H(DL=OUTPUT CHR)
PRINTAD	MACRO	VALNAME
	LOCAL	J1,J2
	PUSHF
	PUSH	AX
	PUSH	BX
	PUSH	DX
	MOV	AH,02H
	MOV	BX,VALNAME
	JMP	short J1
	EVEN
J2:
	INT	21H
	INC	BX
J1:
	MOV	DL,[BX]
	TEST	DL,DL
	JNZ	J2
;
	POP	DX
	POP	BX
	POP	AX
	POPF
	ENDM
;
;
;PRINT ASCIZ
;971227a
;INT 21_02H(DL=OUTPUT CHR)
PRINTA	MACRO	OFSADDR
	LOCAL	J1,J2
	PUSHF
	PUSH	AX
	PUSH	BX
	PUSH	DX
	MOV	AH,02H
	MOV	BX,offset OFSADDR
	JMP	short J1
	EVEN
J2:
	INT	21H
	INC	BX
J1:
	MOV	DL,[BX]
	TEST	DL,DL
	JNZ	J2
;
	POP	DX
	POP	BX
	POP	AX
	POPF
	ENDM
;
;PRINT	OFSADDR
;OUT PUT 
PRINT	MACRO	OFSADDR
	PUSH	AX
	PUSH	DX
	MOV	AH,09H
	MOV	DX,offset OFSADDR
	INT	21H
	POP	DX
	POP	AX
	ENDM
;
;<960226>
PUTCHAR	MACRO	CHR
	PUSH	AX
	PUSH	DX
	MOV	AH,02H
	MOV	DL,CHR
	INT	21H
	POP	DX
	POP	AX
	ENDM
;
;<971227p>
PUTC_DI	MACRO
	PUSH	AX
	MOV	AX,DI
	PUTC_AX
	POP	AX
	ENDM
;
;<971227p>
PUTC_SI	MACRO
	PUSH	AX
	MOV	AX,SI
	PUTC_AX
	POP	AX
	ENDM
;
;<961105>
PUTC_DX	MACRO
	PUSH	AX
	MOV	AX,DX
	PUTC_AX
	POP	AX
	ENDM
;
;<961105>
PUTC_CX	MACRO
	PUSH	AX
	MOV	AX,CX
	PUTC_AX
	POP	AX
	ENDM
;
;<961105>
PUTC_BX	MACRO
	PUSH	AX
	MOV	AX,BX
	PUTC_AX
	POP	AX
	ENDM
;
;<961105>
PUTC_AX	MACRO
	PUSH	AX
	XCHG	AH,AL
	PUTC_AL2
	XCHG	AH,AL
	PUTC_AL
	POP	AX
	ENDM
;
;<961105>
PUTC_AL2	MACRO
	LOCAL	P_J1,P_J2
	PUSHF
	PUSH	AX
	MOV	AH,AL
	SHR	AL,1
	SHR	AL,1
	SHR	AL,1
	SHR	AL,1
	ADD	AL,30H
	CMP	AL,3AH
	JC	P_J2
	ADD	AL,07H
P_J2:	INT	29H
	MOV	AL,AH
	AND	AL,0FH
	ADD	AL,30H
	CMP	AL,3AH
	JC	P_J1
	ADD	AL,07H
P_J1:	INT	29H
	POP	AX
	POPF
	ENDM
;
;<960226>
PUTC_AL	MACRO
	LOCAL	P_J1,P_J2
	PUSHF
	PUSH	AX
	MOV	AH,AL
	SHR	AL,1
	SHR	AL,1
	SHR	AL,1
	SHR	AL,1
	ADD	AL,30H
	CMP	AL,3AH
	JC	P_J2
	ADD	AL,07H
P_J2:	INT	29H
	MOV	AL,AH
	AND	AL,0FH
	ADD	AL,30H
	CMP	AL,3AH
	JC	P_J1
	ADD	AL,07H
P_J1:	INT	29H
	MOV	AL,CR
	INT	29H
	MOV	AL,LF
	INT	29H
	POP	AX
	POPF
	ENDM
;
;<960226>
GETC_AL	MACRO
	PUSH	DX
	MOV	DH,AH
	MOV	AH,06H
	MOV	DL,0FFH
	INT	21H
	MOV	AH,DH
	POP	DX
	ENDM
;
;HEAD END.
;
